# Class RxapFormGroup<T, E>

#### Type Parameters

- T = any
- E extends ValidationErrors = any

#### Hierarchy

- UntypedFormGroup
  - RxapFormGroup

- Defined in packages/angular/forms/src/lib/form-group.ts:49

#####
Index

### Constructors

constructor

### Properties

controlId
controls
dirty$
disabled$
enabled$
errors
errors$
events
status
status$
statusChanges
touch$
value
value$
valueChanges

### Accessors

asyncValidator
controlPath
dirty
disabled
enabled
fullControlPath
invalid
parent
pending
pristine
readonly
root
rxapFormDefinition
touched
untouched
updateOn
valid
validator

### Methods

addAsyncValidators
addControl
addValidators
clearAsyncValidators
clearValidators
contains
disable
disabledWhile
enable
enabledWhile
get
getControl
getError
getRawValue
hasAsyncValidator
hasError
hasErrorAndDirty
hasErrorAndTouched
hasValidator
markAllAsDirty
markAllAsPristine
markAllAsTouched
markAllAsUntouched
markAsDirty
markAsPending
markAsPristine
markAsTouched
markAsUntouched
mergeAsyncValidators
mergeValidators
patchValue
registerControl
removeAsyncValidators
removeControl
removeValidators
reset
select
setAsyncValidators
setControl
setDisable
setEnable
setErrors
setParent
setValidators
setValue
updateValueAndValidity
validateOn

##
Constructors

### constructor

- new RxapFormGroup<T = any, E extends ValidationErrors = any>(
  controls: ExtractAbstractControl<KeyValueControls<T>, T>,
  options: FormGroupOptions,
  ): RxapFormGroup<T, E>

  #### Type Parameters

  - T = any
  - E extends ValidationErrors = any

  #### Parameters

  - controls: ExtractAbstractControl<KeyValueControls<T>, T>
  - options: FormGroupOptions

  #### Returns RxapFormGroup<T, E>

  Overrides UntypedFormGroup.constructor

  - Defined in packages/angular/forms/src/lib/form-group.ts:129

##
Properties

### `Readonly` controlId

controlId: string

- Defined in packages/angular/forms/src/lib/form-group.ts:103

### controls

controls: ExtractAbstractControl<KeyValueControls<T>, T>

Inherited from UntypedFormGroup.controls

- Defined in packages/angular/forms/src/lib/form-group.ts:130

### dirty$

dirty$: Observable<boolean> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:95

### `Readonly` disabled$

disabled$: Observable<boolean> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:98

### `Readonly` enabled$

enabled$: Observable<boolean> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:99

### `Readonly` errors

errors: null | E

An object containing any errors generated by failing validation, or null if there are no errors.

Overrides UntypedFormGroup.errors

- Defined in packages/angular/forms/src/lib/form-group.ts:85

### `Readonly` errors$

errors$: Observable<null | E> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:101

### `Readonly` events

events: Observable<ControlEvent<any>>

A multicasting observable that emits an event every time the state of the control changes. It emits for value, status, pristine or touched changes.

Note: On value change, the emit happens right after a value of this control is updated. The value of a parent control (for example if this FormControl is a part of a FormGroup) is updated later, so accessing a value of a parent control (using the `value` property) from the callback of this event might result in getting a value that has not been updated yet. Subscribe to the `events` of the parent control instead. For other event types, the events are emitted after the parent control has been updated.

Inherited from UntypedFormGroup.events

- Defined in node_modules/@angular/forms/index.d.ts:196

### `Readonly` status

status: ControlState

The validation status of the control.

#### See

FormControlStatus

These status values are mutually exclusive, so a control cannot be both valid AND invalid or invalid AND disabled.

Overrides UntypedFormGroup.status

- Defined in packages/angular/forms/src/lib/form-group.ts:88

### `Readonly` status$

status$: Observable<ControlState> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:100

### `Readonly` statusChanges

statusChanges: Observable<ControlState>

A multicasting observable that emits an event every time the validation `status` of the control recalculates.

#### See

- FormControlStatus
- AbstractControl.status

Overrides UntypedFormGroup.statusChanges

- Defined in packages/angular/forms/src/lib/form-group.ts:89

### touch$

touch$: Observable<boolean> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:94

### `Readonly` value

value: T

The current value of the control.

- For a `FormControl`, the current value.
- For an enabled `FormGroup`, the values of enabled controls as an object with a key-value pair for each member of the group.
- For a disabled `FormGroup`, the values of all controls as an object with a key-value pair for each member of the group.
- For a `FormArray`, the values of enabled controls as an array.

Overrides UntypedFormGroup.value

- Defined in packages/angular/forms/src/lib/form-group.ts:84

### `Readonly` value$

value$: Observable<T> = ...

- Defined in packages/angular/forms/src/lib/form-group.ts:97

### `Readonly` valueChanges

valueChanges: Observable<T>

A multicasting observable that emits an event every time the value of the control changes, in the UI or programmatically. It also emits an event each time you call enable() or disable() without passing along {emitEvent: false} as a function argument.

Note: the emit happens right after a value of this control is updated. The value of a parent control (for example if this FormControl is a part of a FormGroup) is updated later, so accessing a value of a parent control (using the `value` property) from the callback of this event might result in getting a value that has not been updated yet. Subscribe to the `valueChanges` event of the parent control instead.

Overrides UntypedFormGroup.valueChanges

- Defined in packages/angular/forms/src/lib/form-group.ts:86

##
Accessors

### asyncValidator

- get asyncValidator(): null | AsyncValidatorFn

  Returns the function that is used to determine the validity of this control asynchronously. If multiple validators have been added, this will be a single composed function. See `Validators.compose()` for additional information.

  #### Returns null | AsyncValidatorFn

  Inherited from UntypedFormGroup.asyncValidator

  - Defined in node_modules/@angular/forms/index.d.ts:79
- set asyncValidator(asyncValidatorFn: null | AsyncValidatorFn): void

  #### Parameters

  - asyncValidatorFn: null | AsyncValidatorFn

  #### Returns void

  Inherited from UntypedFormGroup.asyncValidator

  - Defined in node_modules/@angular/forms/index.d.ts:80

### controlPath

- get controlPath(): string

  #### Returns string

  - Defined in packages/angular/forms/src/lib/form-group.ts:105

### dirty

- get dirty(): boolean

  A control is `dirty` if the user has changed the value in the UI.

  #### Returns boolean

  True if the user has changed the value of this control in the UI; compare `pristine`. Programmatic changes to a control's value do not mark it dirty.

  Inherited from UntypedFormGroup.dirty

  - Defined in node_modules/@angular/forms/index.d.ts:167

### disabled

- get disabled(): boolean

  A control is `disabled` when its `status` is `DISABLED`.

  Disabled controls are exempt from validation checks and are not included in the aggregate value of their ancestor controls.

  #### Returns boolean

  True if the control is disabled, false otherwise.

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.disabled

  - Defined in node_modules/@angular/forms/index.d.ts:134

### enabled

- get enabled(): boolean

  A control is `enabled` as long as its `status` is not `DISABLED`.

  #### Returns boolean

  True if the control has any status other than 'DISABLED', false if the status is 'DISABLED'.

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.enabled

  - Defined in node_modules/@angular/forms/index.d.ts:144

### fullControlPath

- get fullControlPath(): string

  #### Returns string

  - Defined in packages/angular/forms/src/lib/form-group.ts:119

### invalid

- get invalid(): boolean

  A control is `invalid` when its `status` is `INVALID`.

  #### Returns boolean

  True if this control has failed one or more of its validation checks, false otherwise.

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.invalid

  - Defined in node_modules/@angular/forms/index.d.ts:113

### parent

- get parent(): null | FormGroup<any> | FormArray<any>

  The parent control.

  #### Returns null | FormGroup<any> | FormArray<any>

  Inherited from UntypedFormGroup.parent

  - Defined in node_modules/@angular/forms/index.d.ts:84

### pending

- get pending(): boolean

  A control is `pending` when its `status` is `PENDING`.

  #### Returns boolean

  True if this control is in the process of conducting a validation check, false otherwise.

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.pending

  - Defined in node_modules/@angular/forms/index.d.ts:122

### pristine

- get pristine(): boolean

  A control is `pristine` if the user has not yet changed the value in the UI.

  #### Returns boolean

  True if the user has not yet changed the value in the UI; compare `dirty`. Programmatic changes to a control's value do not mark it dirty.

  Inherited from UntypedFormGroup.pristine

  - Defined in node_modules/@angular/forms/index.d.ts:157
- set pristine(value: boolean): void

  #### Parameters

  - value: boolean

  #### Returns void

  Inherited from UntypedFormGroup.pristine

  - Defined in node_modules/@angular/forms/index.d.ts:158

### readonly

- get readonly(): boolean

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:70
- set readonly(value: boolean): void

  #### Parameters

  - value: boolean

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:74

### root

- get root(): AbstractControl

  Retrieves the top-level ancestor of this control.

  #### Returns AbstractControl

  Inherited from UntypedFormGroup.root

  - Defined in node_modules/@angular/forms/index.d.ts:676

### rxapFormDefinition

- get rxapFormDefinition(): | undefined
  | Partial<FormDefinition<T, any, any>> & {
  [K in string | number | symbol]: T[K] extends U[]
  ? | FormDefinitionArray<FormType<U>>
  | FormDefinitionArray<RxapFormControl<U, any, any>>
  | RxapFormArray<U, any, any>
  | RxapFormControl<any[any], any, any>
  : T[K] extends Record<string, any>
  ?
  | Partial<FormDefinition<any[any], any, any>> & {
  [K in string | number | symbol]: any[any][K] extends U[]
  ? | FormDefinitionArray<(...)>
  | FormDefinitionArray<(...)>
  | RxapFormArray<(...), (...), (...)>
  | RxapFormControl<(...), (...), (...)>
  : (...)[(...)] extends Record<(...), (...)>
  ? (...) | (...)
  : RxapFormControl<(...), (...), (...)>
  } & Partial<FormDefinition<any[any], any, any>>
  | RxapFormControl<any[any], any, any>
  : RxapFormControl<NonEmpty<T[K]>, any, any>
  } & FormDefinition<T, any, any>
  `Internal`

  #### Returns
  | undefined
  | Partial<FormDefinition<T, any, any>> & {
  [K in string | number | symbol]: T[K] extends U[]
  ? | FormDefinitionArray<FormType<U>>
  | FormDefinitionArray<RxapFormControl<U, any, any>>
  | RxapFormArray<U, any, any>
  | RxapFormControl<any[any], any, any>
  : T[K] extends Record<string, any>
  ?
  | Partial<FormDefinition<any[any], any, any>> & {
  [K in string | number | symbol]: any[any][K] extends U[]
  ? | FormDefinitionArray<(...)>
  | FormDefinitionArray<(...)>
  | RxapFormArray<(...), (...), (...)>
  | RxapFormControl<(...), (...), (...)>
  : (...)[(...)] extends Record<(...), (...)>
  ? (...) | (...)
  : RxapFormControl<(...), (...), (...)>
  } & Partial<FormDefinition<any[any], any, any>>
  | RxapFormControl<any[any], any, any>
  : RxapFormControl<NonEmpty<T[K]>, any, any>
  } & FormDefinition<T, any, any>

  - Defined in packages/angular/forms/src/lib/form-group.ts:56

### touched

- get touched(): boolean

  True if the control is marked as `touched`.

  A control is marked `touched` once the user has triggered a `blur` event on it.

  #### Returns boolean

  Inherited from UntypedFormGroup.touched

  - Defined in node_modules/@angular/forms/index.d.ts:174
- set touched(value: boolean): void

  #### Parameters

  - value: boolean

  #### Returns void

  Inherited from UntypedFormGroup.touched

  - Defined in node_modules/@angular/forms/index.d.ts:175

### untouched

- get untouched(): boolean

  True if the control has not been marked as touched

  A control is `untouched` if the user has not yet triggered a `blur` event on it.

  #### Returns boolean

  Inherited from UntypedFormGroup.untouched

  - Defined in node_modules/@angular/forms/index.d.ts:183

### updateOn

- get updateOn(): FormHooks

  Reports the update strategy of the `AbstractControl` (meaning the event on which the control updates itself). Possible values: `'change'` | `'blur'` | `'submit'` Default value: `'change'`

  #### Returns FormHooks

  Inherited from UntypedFormGroup.updateOn

  - Defined in node_modules/@angular/forms/index.d.ts:223

### valid

- get valid(): boolean

  A control is `valid` when its `status` is `VALID`.

  #### Returns boolean

  True if the control has passed all of its validation tests, false otherwise.

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.valid

  - Defined in node_modules/@angular/forms/index.d.ts:104

### validator

- get validator(): null | ValidatorFn

  Returns the function that is used to determine the validity of this control synchronously. If multiple validators have been added, this will be a single composed function. See `Validators.compose()` for additional information.

  #### Returns null | ValidatorFn

  Inherited from UntypedFormGroup.validator

  - Defined in node_modules/@angular/forms/index.d.ts:72
- set validator(validatorFn: null | ValidatorFn): void

  #### Parameters

  - validatorFn: null | ValidatorFn

  #### Returns void

  Inherited from UntypedFormGroup.validator

  - Defined in node_modules/@angular/forms/index.d.ts:73

##
Methods

### addAsyncValidators

- addAsyncValidators(validators: AsyncValidatorFn | AsyncValidatorFn[]): void

  Add an asynchronous validator or validators to this control, without affecting other validators.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  Adding a validator that already exists will have no effect.

  #### Parameters

  - validators: AsyncValidatorFn | AsyncValidatorFn[]

    The new asynchronous validator function or functions to add to this control.

  #### Returns void

  Inherited from UntypedFormGroup.addAsyncValidators

  - Defined in node_modules/@angular/forms/index.d.ts:270

### addControl

- addControl<K extends string>(name: K, control: AbstractControl<T[K]>): void

  Add a control to this group. In a strongly-typed group, the control must be in the group's type (possibly as an optional key).

  If a control with a given name already exists, it would not be replaced with a new one. If you want to replace an existing control, use the FormGroup#setControl setControl method instead. This method also updates the value and validity of the control.

  #### Type Parameters

  - K extends string

  #### Parameters

  - name: K

    The control name to add to the collection

  - control: AbstractControl<T[K]>

    Provides the control for the given name

  #### Returns void

  Overrides UntypedFormGroup.addControl

  - Defined in packages/angular/forms/src/lib/form-group.ts:184

### addValidators

- addValidators(validators: ValidatorFn | ValidatorFn[]): void

  Add a synchronous validator or validators to this control, without affecting other validators.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  Adding a validator that already exists will have no effect. If duplicate validator functions are present in the `validators` array, only the first instance would be added to a form control.

  #### Parameters

  - validators: ValidatorFn | ValidatorFn[]

    The new validator function or functions to add to this control.

  #### Returns void

  Inherited from UntypedFormGroup.addValidators

  - Defined in node_modules/@angular/forms/index.d.ts:258

### clearAsyncValidators

- clearAsyncValidators(): void

  Empties out the async validator list.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  #### Returns void

  Inherited from UntypedFormGroup.clearAsyncValidators

  - Defined in node_modules/@angular/forms/index.d.ts:361

### clearValidators

- clearValidators(): void

  Empties out the synchronous validator list.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  #### Returns void

  Inherited from UntypedFormGroup.clearValidators

  - Defined in node_modules/@angular/forms/index.d.ts:353

### contains

- contains(controlName: ExtractStrings<T>): boolean

  Check whether there is an enabled control with the given name in the group.

  Reports false for disabled controls. If you'd like to check for existence in the group only, use get instead.

  #### Parameters

  - controlName: ExtractStrings<T>

    The control name to check for existence in the collection

  #### Returns boolean

  false for disabled controls, true otherwise.

  Overrides UntypedFormGroup.contains

  - Defined in packages/angular/forms/src/lib/form-group.ts:195

### disable

- disable(opts?: { emitEvent?: boolean; onlySelf?: boolean }): void

  Disables the control. This means the control is exempt from validation checks and excluded from the aggregate value of any parent. Its status is `DISABLED`.

  If the control has children, all children are also disabled.

  #### Parameters

  - `Optional` opts: { emitEvent?: boolean; onlySelf?: boolean }

    Configuration options that determine how the control propagates changes and emits events after the control is disabled.

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `statusChanges`, `valueChanges` and `events` observables emit events with the latest status and value when the control is disabled. When false, no events are emitted.

  #### Returns void

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.disable

  - Defined in node_modules/@angular/forms/index.d.ts:498

### disabledWhile

- disabledWhile(
  observable: Observable<boolean>,
  options?: ControlOptions,
  ): Subscription

  #### Parameters

  - observable: Observable<boolean>
  - `Optional` options: ControlOptions

  #### Returns Subscription

  - Defined in packages/angular/forms/src/lib/form-group.ts:268

### enable

- enable(opts?: { emitEvent?: boolean; onlySelf?: boolean }): void

  Enables the control. This means the control is included in validation checks and the aggregate value of its parent. Its status recalculates based on its value and its validators.

  By default, if the control has children, all children are enabled.

  #### Parameters

  - `Optional` opts: { emitEvent?: boolean; onlySelf?: boolean }

    Configure options that control how the control propagates changes and emits events when marked as untouched

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `statusChanges`, `valueChanges` and `events` observables emit events with the latest status and value when the control is enabled. When false, no events are emitted.

  #### Returns void

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.enable

  - Defined in node_modules/@angular/forms/index.d.ts:520

### enabledWhile

- enabledWhile(
  observable: Observable<boolean>,
  options?: ControlOptions,
  ): Subscription

  #### Parameters

  - observable: Observable<boolean>
  - `Optional` options: ControlOptions

  #### Returns Subscription

  - Defined in packages/angular/forms/src/lib/form-group.ts:275

### get

- get<K1 extends string | number | symbol>(path: [K1]): AbstractControl<T[K1]>

  Retrieves a child control given the control's name or path.

  This signature for get supports strings and `const` arrays (`.get(['foo', 'bar'] as const)`).

  #### Type Parameters

  - K1 extends string | number | symbol

  #### Parameters

  - path: [K1]

  #### Returns AbstractControl<T[K1]>

  Overrides UntypedFormGroup.get

  - Defined in packages/angular/forms/src/lib/form-group.ts:145
- get<K1 extends string | number | symbol, K2 extends string | number | symbol>(
  path: [K1, K2],
  ): AbstractControl<T[K1][K2]>

  Retrieves a child control given the control's name or path.

  This signature for `get` supports non-const (mutable) arrays. Inferred type information will not be as robust, so prefer to pass a `readonly` array if possible.

  #### Type Parameters

  - K1 extends string | number | symbol
  - K2 extends string | number | symbol

  #### Parameters

  - path: [K1, K2]

  #### Returns AbstractControl<T[K1][K2]>

  Overrides UntypedFormGroup.get

  - Defined in packages/angular/forms/src/lib/form-group.ts:146
- get<
  K1 extends string
  | number
  | symbol,
  K2 extends string | number | symbol,
  K3 extends string | number | symbol,
  >(
  path: [K1, K2, K3],
  ): AbstractControl<T[K1][K2][K3]>

  #### Type Parameters

  - K1 extends string | number | symbol
  - K2 extends string | number | symbol
  - K3 extends string | number | symbol

  #### Parameters

  - path: [K1, K2, K3]

  #### Returns AbstractControl<T[K1][K2][K3]>

  Overrides UntypedFormGroup.get

  - Defined in packages/angular/forms/src/lib/form-group.ts:149
- get(path: string): AbstractControl

  #### Parameters

  - path: string

  #### Returns AbstractControl

  Overrides UntypedFormGroup.get

  - Defined in packages/angular/forms/src/lib/form-group.ts:154

### getControl

- getControl<P1 extends string | number | symbol>(
  prop1: P1,
  ): AbstractControl<T[P1]>

  #### Type Parameters

  - P1 extends string | number | symbol

  #### Parameters

  - prop1: P1

  #### Returns AbstractControl<T[P1]>

  - Defined in packages/angular/forms/src/lib/form-group.ts:159
- getControl<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  >(
  prop1: P1,
  prop2: P2,
  ): AbstractControl<T[P1][P2]>

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol

  #### Parameters

  - prop1: P1
  - prop2: P2

  #### Returns AbstractControl<T[P1][P2]>

  - Defined in packages/angular/forms/src/lib/form-group.ts:160
- getControl<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  P3 extends string | number | symbol,
  >(
  prop1: P1,
  prop2: P2,
  prop3: P3,
  ): AbstractControl<T[P1][P2][P3]>

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol
  - P3 extends string | number | symbol

  #### Parameters

  - prop1: P1
  - prop2: P2
  - prop3: P3

  #### Returns AbstractControl<T[P1][P2][P3]>

  - Defined in packages/angular/forms/src/lib/form-group.ts:164
- getControl<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  P3 extends string | number | symbol,
  P4 extends string | number | symbol,
  >(
  prop1: P1,
  prop2: P2,
  prop3: P3,
  prop4: P4,
  ): AbstractControl<T[P1][P2][P3][P4]>

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol
  - P3 extends string | number | symbol
  - P4 extends string | number | symbol

  #### Parameters

  - prop1: P1
  - prop2: P2
  - prop3: P3
  - prop4: P4

  #### Returns AbstractControl<T[P1][P2][P3][P4]>

  - Defined in packages/angular/forms/src/lib/form-group.ts:169

### getError

- getError<
  K extends string
  | number
  | symbol,
  K1 extends string | number | symbol,
  >(
  errorCode: K,
  path?: [K1],
  ): null | E[K]

  #### Type Parameters

  - K extends string | number | symbol
  - K1 extends string | number | symbol

  #### Parameters

  - errorCode: K

    The code of the error to check

  - `Optional` path: [K1]

    A list of control names that designates how to move from the current control to the control that should be queried for errors.

  #### Returns null | E[K]

  error data for that particular error. If the control or error is not present, null is returned.

  #### Description

  Reports error data for the control with the given path.

  #### Usage Notes

  For example, for the following `FormGroup`:

      form = new FormGroup({
        address: new FormGroup({ street: new FormControl() })
      });

  The path to the 'street' control from the root form would be 'address' -> 'street'.

  It can be provided to this method in one of two formats:

  1. An array of string control names, e.g. `['address', 'street']`
  2. A period-delimited list of control names in one string, e.g. `'address.street'`

  Overrides UntypedFormGroup.getError

  - Defined in packages/angular/forms/src/lib/form-group.ts:376
- getError<
  K extends string
  | number
  | symbol,
  K1 extends string | number | symbol,
  K2 extends string | number | symbol,
  >(
  errorCode: K,
  path?: [K1, K2],
  ): null | E[K]

  #### Type Parameters

  - K extends string | number | symbol
  - K1 extends string | number | symbol
  - K2 extends string | number | symbol

  #### Parameters

  - errorCode: K
  - `Optional` path: [K1, K2]

  #### Returns null | E[K]

  Overrides UntypedFormGroup.getError

  - Defined in packages/angular/forms/src/lib/form-group.ts:380
- getError<
  K extends string
  | number
  | symbol,
  K1 extends string | number | symbol,
  K2 extends string | number | symbol,
  K3 extends string | number | symbol,
  >(
  errorCode: K,
  path?: [K1, K2, K3],
  ): null | E[K]

  #### Type Parameters

  - K extends string | number | symbol
  - K1 extends string | number | symbol
  - K2 extends string | number | symbol
  - K3 extends string | number | symbol

  #### Parameters

  - errorCode: K
  - `Optional` path: [K1, K2, K3]

  #### Returns null | E[K]

  Overrides UntypedFormGroup.getError

  - Defined in packages/angular/forms/src/lib/form-group.ts:385
- getError<K extends string | number | symbol>(
  errorCode: K,
  path?: string,
  ): null | E[K]

  #### Type Parameters

  - K extends string | number | symbol

  #### Parameters

  - errorCode: K
  - `Optional` path: string

  #### Returns null | E[K]

  Overrides UntypedFormGroup.getError

  - Defined in packages/angular/forms/src/lib/form-group.ts:391

### getRawValue

- getRawValue(): T

  The aggregate value of the `FormGroup`, including any disabled controls.

  Retrieves all values regardless of disabled status.

  #### Returns T

  Overrides UntypedFormGroup.getRawValue

  - Defined in packages/angular/forms/src/lib/form-group.ts:141

### hasAsyncValidator

- hasAsyncValidator(validator: AsyncValidatorFn): boolean

  Check whether an asynchronous validator function is present on this control. The provided validator must be a reference to the exact same function that was provided.

  #### Parameters

  - validator: AsyncValidatorFn

    The asynchronous validator to check for presence. Compared by function reference.

  #### Returns boolean

  Whether the provided asynchronous validator was found on this control.

  Inherited from UntypedFormGroup.hasAsyncValidator

  - Defined in node_modules/@angular/forms/index.d.ts:345

### hasError

- hasError<K1 extends string | number | symbol>(
  errorCode: ExtractStrings<E>,
  path?: [K1],
  ): boolean

  #### Type Parameters

  - K1 extends string | number | symbol

  #### Parameters

  - errorCode: ExtractStrings<E>

    The code of the error to check

  - `Optional` path: [K1]

    A list of control names that designates how to move from the current control to the control that should be queried for errors.

  #### Returns boolean

  whether the given error is present in the control at the given path.

  If the control is not present, false is returned.

  #### Description

  Reports whether the control with the given path has the error specified.

  #### Usage Notes

  For example, for the following `FormGroup`:

      form = new FormGroup({
        address: new FormGroup({ street: new FormControl() })
      });

  The path to the 'street' control from the root form would be 'address' -> 'street'.

  It can be provided to this method in one of two formats:

  1. An array of string control names, e.g. `['address', 'street']`
  2. A period-delimited list of control names in one string, e.g. `'address.street'`

  If no path is given, this method checks for the error on the current control.

  Overrides UntypedFormGroup.hasError

  - Defined in packages/angular/forms/src/lib/form-group.ts:354
- hasError<
  K1 extends string
  | number
  | symbol,
  K2 extends string | number | symbol,
  >(
  errorCode: ExtractStrings<E>,
  path?: [K1, K2],
  ): boolean

  #### Type Parameters

  - K1 extends string | number | symbol
  - K2 extends string | number | symbol

  #### Parameters

  - errorCode: ExtractStrings<E>
  - `Optional` path: [K1, K2]

  #### Returns boolean

  Overrides UntypedFormGroup.hasError

  - Defined in packages/angular/forms/src/lib/form-group.ts:358
- hasError<
  K1 extends string
  | number
  | symbol,
  K2 extends string | number | symbol,
  K3 extends string | number | symbol,
  >(
  errorCode: ExtractStrings<E>,
  path?: [K1, K2, K3],
  ): boolean

  #### Type Parameters

  - K1 extends string | number | symbol
  - K2 extends string | number | symbol
  - K3 extends string | number | symbol

  #### Parameters

  - errorCode: ExtractStrings<E>
  - `Optional` path: [K1, K2, K3]

  #### Returns boolean

  Overrides UntypedFormGroup.hasError

  - Defined in packages/angular/forms/src/lib/form-group.ts:362
- hasError(errorCode: ExtractStrings<E>, path?: string): boolean

  #### Parameters

  - errorCode: ExtractStrings<E>
  - `Optional` path: string

  #### Returns boolean

  Overrides UntypedFormGroup.hasError

  - Defined in packages/angular/forms/src/lib/form-group.ts:367

### hasErrorAndDirty

- hasErrorAndDirty<P1 extends string | number | symbol>(
  error: ExtractStrings<E>,
  prop1?: P1,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:426
- hasErrorAndDirty<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  >(
  error: ExtractStrings<E>,
  prop1?: P1,
  prop2?: P2,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1
  - `Optional` prop2: P2

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:430
- hasErrorAndDirty<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  P3 extends string | number | symbol,
  >(
  error: ExtractStrings<E>,
  prop1?: P1,
  prop2?: P2,
  prop3?: P3,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol
  - P3 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1
  - `Optional` prop2: P2
  - `Optional` prop3: P3

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:435
- hasErrorAndDirty<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  P3 extends string | number | symbol,
  P4 extends string | number | symbol,
  >(
  error: ExtractStrings<E>,
  prop1?: P1,
  prop2?: P2,
  prop3?: P3,
  prop4?: P4,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol
  - P3 extends string | number | symbol
  - P4 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1
  - `Optional` prop2: P2
  - `Optional` prop3: P3
  - `Optional` prop4: P4

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:440

### hasErrorAndTouched

- hasErrorAndTouched<P1 extends string | number | symbol>(
  error: ExtractStrings<E>,
  prop1?: P1,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:396
- hasErrorAndTouched<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  >(
  error: ExtractStrings<E>,
  prop1?: P1,
  prop2?: P2,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1
  - `Optional` prop2: P2

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:400
- hasErrorAndTouched<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  P3 extends string | number | symbol,
  >(
  error: ExtractStrings<E>,
  prop1?: P1,
  prop2?: P2,
  prop3?: P3,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol
  - P3 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1
  - `Optional` prop2: P2
  - `Optional` prop3: P3

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:405
- hasErrorAndTouched<
  P1 extends string
  | number
  | symbol,
  P2 extends string | number | symbol,
  P3 extends string | number | symbol,
  P4 extends string | number | symbol,
  >(
  error: ExtractStrings<E>,
  prop1?: P1,
  prop2?: P2,
  prop3?: P3,
  prop4?: P4,
  ): boolean

  #### Type Parameters

  - P1 extends string | number | symbol
  - P2 extends string | number | symbol
  - P3 extends string | number | symbol
  - P4 extends string | number | symbol

  #### Parameters

  - error: ExtractStrings<E>
  - `Optional` prop1: P1
  - `Optional` prop2: P2
  - `Optional` prop3: P3
  - `Optional` prop4: P4

  #### Returns boolean

  - Defined in packages/angular/forms/src/lib/form-group.ts:410

### hasValidator

- hasValidator(validator: ValidatorFn): boolean

  Check whether a synchronous validator function is present on this control. The provided validator must be a reference to the exact same function that was provided.

  #### Parameters

  - validator: ValidatorFn

    The validator to check for presence. Compared by function reference.

  #### Returns boolean

  Whether the provided validator was found on this control.

  #### Usage Notes

  ### Reference to a ValidatorFn

      // Reference to the RequiredValidator
      const ctrl = new FormControl<number | null>(0, Validators.required);
      expect(ctrl.hasValidator(Validators.required)).toEqual(true)

      // Reference to anonymous function inside MinValidator
      const minValidator = Validators.min(3);
      const ctrl = new FormControl<number | null>(0, minValidator);
      expect(ctrl.hasValidator(minValidator)).toEqual(true)
      expect(ctrl.hasValidator(Validators.min(3))).toEqual(false)

  Inherited from UntypedFormGroup.hasValidator

  - Defined in node_modules/@angular/forms/index.d.ts:336

### markAllAsDirty

- markAllAsDirty(): void

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:314

### markAllAsPristine

- markAllAsPristine(): void

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:318

### markAllAsTouched

- markAllAsTouched(opts?: { emitEvent?: boolean }): void

  Marks the control and all its descendant controls as `touched`.

  #### Parameters

  - `Optional` opts: { emitEvent?: boolean }

    Configuration options that determine how the control propagates changes and emits events after marking is applied.

    - `emitEvent`: When true or not supplied (the default), the `events` observable emits a `TouchedChangeEvent` with the `touched` property being `true`. When false, no events are emitted.

  #### Returns void

  #### See

  ()

  Inherited from UntypedFormGroup.markAllAsTouched

  - Defined in node_modules/@angular/forms/index.d.ts:392

### markAllAsUntouched

- markAllAsUntouched(): void

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:322

### markAsDirty

- markAsDirty(opts?: OnlySelf): void

  Marks the control as `dirty`. A control becomes dirty when the control's value is changed through the UI; compare `markAsTouched`.

  #### Parameters

  - `Optional` opts: OnlySelf

    Configuration options that determine how the control propagates changes and emits events after marking is applied.

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `events` observable emits a `PristineChangeEvent` with the `pristine` property being `false`. When false, no events are emitted.

  #### Returns void

  #### See

  - ()
  - ()
  - ()

  Overrides UntypedFormGroup.markAsDirty

  - Defined in packages/angular/forms/src/lib/form-group.ts:309

### markAsPending

- markAsPending(opts?: { emitEvent?: boolean; onlySelf?: boolean }): void

  Marks the control as `pending`.

  A control is pending while the control performs async validation.

  #### Parameters

  - `Optional` opts: { emitEvent?: boolean; onlySelf?: boolean }

    Configuration options that determine how the control propagates changes and emits events after marking is applied.

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `statusChanges` observable emits an event with the latest status the control is marked pending and the `events` observable emits a `StatusChangeEvent` with the `status` property being `PENDING` When false, no events are emitted.

  #### Returns void

  #### See

  AbstractControl.status

  Inherited from UntypedFormGroup.markAsPending

  - Defined in node_modules/@angular/forms/index.d.ts:477

### markAsPristine

- markAsPristine(opts?: OnlySelf): void

  Marks the control as `pristine`.

  If the control has any children, marks all children as `pristine`, and recalculates the `pristine` status of all parent controls.

  #### Parameters

  - `Optional` opts: OnlySelf

    Configuration options that determine how the control emits events after marking is applied.

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `events` observable emits a `PristineChangeEvent` with the `pristine` property being `true`. When false, no events are emitted.

  #### Returns void

  #### See

  - ()
  - ()
  - ()

  Overrides UntypedFormGroup.markAsPristine

  - Defined in packages/angular/forms/src/lib/form-group.ts:304

### markAsTouched

- markAsTouched(opts?: OnlySelf): void

  Marks the control as `touched`. A control is touched by focus and blur events that do not change the value.

  #### Parameters

  - `Optional` opts: OnlySelf

    Configuration options that determine how the control propagates changes and emits events after marking is applied.

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `events` observable emits a `TouchedChangeEvent` with the `touched` property being `true`. When false, no events are emitted.

  #### Returns void

  #### See

  - ()
  - ()
  - ()

  Overrides UntypedFormGroup.markAsTouched

  - Defined in packages/angular/forms/src/lib/form-group.ts:294

### markAsUntouched

- markAsUntouched(opts?: OnlySelf): void

  Marks the control as `untouched`.

  If the control has any children, also marks all children as `untouched` and recalculates the `touched` status of all parent controls.

  #### Parameters

  - `Optional` opts: OnlySelf

    Configuration options that determine how the control propagates changes and emits events after the marking is applied.

    - `onlySelf`: When true, mark only this control. When false or not supplied, marks all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `events` observable emits a `TouchedChangeEvent` with the `touched` property being `false`. When false, no events are emitted.

  #### Returns void

  #### See

  - ()
  - ()
  - ()

  Overrides UntypedFormGroup.markAsUntouched

  - Defined in packages/angular/forms/src/lib/form-group.ts:299

### mergeAsyncValidators

- mergeAsyncValidators(validators: AsyncValidator): void

  #### Parameters

  - validators: AsyncValidator

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:286

### mergeValidators

- mergeValidators(validators: Validator): void

  #### Parameters

  - validators: Validator

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:282

### patchValue

- patchValue(
  valueOrObservable: Observable<Partial<T>>,
  options?: ControlEventOptions,
  ): Subscription

  Patches the value of the `FormGroup`. It accepts an object with control names as keys, and does its best to match the values to the correct controls in the group.

  It accepts both super-sets and sub-sets of the group without throwing an error.

  #### Parameters

  - valueOrObservable: Observable<Partial<T>>
  - `Optional` options: ControlEventOptions

    Configuration options that determine how the control propagates changes and emits events after the value is patched.

    - `onlySelf`: When true, each change only affects this control and not its parent. Default is true.
    - `emitEvent`: When true or not supplied (the default), both the `statusChanges` and `valueChanges` observables emit events with the latest status and value when the control value is updated. When false, no events are emitted. The configuration options are passed to the updateValueAndValidity method.

  #### Returns Subscription

  #### Usage Notes

  ### Patch the value for a form group

      const form = new FormGroup({
         first: new FormControl(),
         last: new FormControl()
      });
      console.log(form.value);   // {first: null, last: null}

      form.patchValue({first: 'Nancy'});
      console.log(form.value);   // {first: 'Nancy', last: null}

  Overrides UntypedFormGroup.patchValue

  - Defined in packages/angular/forms/src/lib/form-group.ts:246
- patchValue(valueOrObservable: Partial<T>, options?: ControlEventOptions): void

  #### Parameters

  - valueOrObservable: Partial<T>
  - `Optional` options: ControlEventOptions

  #### Returns void

  Overrides UntypedFormGroup.patchValue

  - Defined in packages/angular/forms/src/lib/form-group.ts:250

### registerControl

- registerControl<K extends string>(name: K, control: any): any

  Registers a control with the group's list of controls. In a strongly-typed group, the control must be in the group's type (possibly as an optional key).

  This method does not update the value or validity of the control. Use FormGroup#addControl addControl instead.

  #### Type Parameters

  - K extends string

  #### Parameters

  - name: K

    The control name to register in the collection

  - control: any

    Provides the control for the given name

  #### Returns any

  Inherited from UntypedFormGroup.registerControl

  - Defined in node_modules/@angular/forms/index.d.ts:2647
- registerControl(
  this: FormGroup<{ [key: string]: AbstractControl<any, any> }>,
  name: string,
  control: AbstractControl<any>,
  ): AbstractControl<any>

  Registers a control with the group's list of controls. In a strongly-typed group, the control must be in the group's type (possibly as an optional key).

  This method does not update the value or validity of the control. Use FormGroup#addControl addControl instead.

  #### Parameters

  - this: FormGroup<{ [key: string]: AbstractControl<any, any> }>
  - name: string

    The control name to register in the collection

  - control: AbstractControl<any>

    Provides the control for the given name

  #### Returns AbstractControl<any>

  Inherited from UntypedFormGroup.registerControl

  - Defined in node_modules/@angular/forms/index.d.ts:2648

### removeAsyncValidators

- removeAsyncValidators(validators: AsyncValidatorFn | AsyncValidatorFn[]): void

  Remove an asynchronous validator from this control, without affecting other validators. Validators are compared by function reference; you must pass a reference to the exact same validator function as the one that was originally set. If a provided validator is not found, it is ignored.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  #### Parameters

  - validators: AsyncValidatorFn | AsyncValidatorFn[]

    The asynchronous validator or validators to remove.

  #### Returns void

  Inherited from UntypedFormGroup.removeAsyncValidators

  - Defined in node_modules/@angular/forms/index.d.ts:312

### removeControl

- removeControl(name: ExtractStrings<T>): void

  #### Parameters

  - name: ExtractStrings<T>

  #### Returns void

  Overrides UntypedFormGroup.removeControl

  - Defined in packages/angular/forms/src/lib/form-group.ts:191

### removeValidators

- removeValidators(validators: ValidatorFn | ValidatorFn[]): void

  Remove a synchronous validator from this control, without affecting other validators. Validators are compared by function reference; you must pass a reference to the exact same validator function as the one that was originally set. If a provided validator is not found, it is ignored.

  #### Parameters

  - validators: ValidatorFn | ValidatorFn[]

    The validator or validators to remove.

  #### Returns void

  #### Usage Notes

  ### Reference to a ValidatorFn

      // Reference to the RequiredValidator
      const ctrl = new FormControl<string | null>('', Validators.required);
      ctrl.removeValidators(Validators.required);

      // Reference to anonymous function inside MinValidator
      const minValidator = Validators.min(3);
      const ctrl = new FormControl<string | null>('', minValidator);
      expect(ctrl.hasValidator(minValidator)).toEqual(true)
      expect(ctrl.hasValidator(Validators.min(3))).toEqual(false)

      ctrl.removeValidators(minValidator);

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  Inherited from UntypedFormGroup.removeValidators

  - Defined in node_modules/@angular/forms/index.d.ts:300

### reset

- reset(formState?: Partial<T>, options?: ControlEventOptions): void

  Resets the `FormGroup`, marks all descendants `pristine` and `untouched` and sets the value of all descendants to their default values, or null if no defaults were provided.

  You reset to a specific form state by passing in a map of states that matches the structure of your form, with control names as keys. The state is a standalone value or a form state object with both a value and a disabled status.

  #### Parameters

  - `Optional` formState: Partial<T>
  - `Optional` options: ControlEventOptions

    Configuration options that determine how the control propagates changes and emits events when the group is reset.

    - `onlySelf`: When true, each change only affects this control, and not its parent. Default is false.
    - `emitEvent`: When true or not supplied (the default), both the `statusChanges` and `valueChanges` observables emit events with the latest status and value when the control is reset. When false, no events are emitted. The configuration options are passed to the updateValueAndValidity method.

  #### Returns void

  #### Usage Notes

  ### Reset the form group values

      const form = new FormGroup({
        first: new FormControl('first name'),
        last: new FormControl('last name')
      });

      console.log(form.value);  // {first: 'first name', last: 'last name'}

      form.reset({ first: 'name', last: 'last name' });

      console.log(form.value);  // {first: 'name', last: 'last name'}

  ### Reset the form group values and disabled status

      const form = new FormGroup({
        first: new FormControl('first name'),
        last: new FormControl('last name')
      });

      form.reset({
        first: {value: 'name', disabled: true},
        last: 'last'
      });

      console.log(form.value);  // {last: 'last'}
      console.log(form.get('first').status);  // 'DISABLED'

  Overrides UntypedFormGroup.reset

  - Defined in packages/angular/forms/src/lib/form-group.ts:326

### select

- select<R>(mapFn: (state: T) => R): Observable<R>

  #### Type Parameters

  - R

  #### Parameters

  - mapFn: (state: T) => R

  #### Returns Observable<R>

  - Defined in packages/angular/forms/src/lib/form-group.ts:137

### setAsyncValidators

- setAsyncValidators(
  newValidator: AsyncValidator,
  updateValueAndValidity?: boolean,
  ): void

  Sets the asynchronous validators that are active on this control. Calling this overwrites any existing asynchronous validators.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  If you want to add a new validator without affecting existing ones, consider using `addAsyncValidators()` method instead.

  #### Parameters

  - newValidator: AsyncValidator
  - updateValueAndValidity: boolean = true

  #### Returns void

  Overrides UntypedFormGroup.setAsyncValidators

  - Defined in packages/angular/forms/src/lib/form-group.ts:340

### setControl

- setControl<K extends string>(name: K, control: AbstractControl<T[K]>): void

  Replace an existing control. In a strongly-typed group, the control must be in the group's type (possibly as an optional key).

  If a control with a given name does not exist in this `FormGroup`, it will be added.

  #### Type Parameters

  - K extends string

  #### Parameters

  - name: K

    The control name to replace in the collection

  - control: AbstractControl<T[K]>

    Provides the control for the given name

  #### Returns void

  Overrides UntypedFormGroup.setControl

  - Defined in packages/angular/forms/src/lib/form-group.ts:199

### setDisable

- setDisable(disable?: boolean, opts?: ControlEventOptions): void

  #### Parameters

  - disable: boolean = true
  - `Optional` opts: ControlEventOptions

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:460

### setEnable

- setEnable(enable?: boolean, opts?: ControlEventOptions): void

  #### Parameters

  - enable: boolean = true
  - `Optional` opts: ControlEventOptions

  #### Returns void

  - Defined in packages/angular/forms/src/lib/form-group.ts:456

### setErrors

- setErrors(errors: null | Partial<E>, opts?: EmitEvent): void

  Sets errors on a form control when running validations manually, rather than automatically.

  Calling `setErrors` also updates the validity of the parent control.

  #### Parameters

  - errors: null | Partial<E>
  - opts: EmitEvent = {}

    Configuration options that determine how the control propagates changes and emits events after the control errors are set.

    - `emitEvent`: When true or not supplied (the default), the `statusChanges` observable emits an event after the errors are set.

  #### Returns void

  #### Usage Notes

  ### Manually set the errors for a control

      const login = new FormControl('someLogin');
      login.setErrors({
        notUnique: true
      });

      expect(login.valid).toEqual(false);
      expect(login.errors).toEqual({ notUnique: true });

      login.setValue('someOtherLogin');

      expect(login.valid).toEqual(true);

  Overrides UntypedFormGroup.setErrors

  - Defined in packages/angular/forms/src/lib/form-group.ts:372

### setParent

- setParent(parent: null | FormGroup<any> | FormArray<any>): void

  Sets the parent of the control

  #### Parameters

  - parent: null | FormGroup<any> | FormArray<any>

    The new parent.

  #### Returns void

  Inherited from UntypedFormGroup.setParent

  - Defined in node_modules/@angular/forms/index.d.ts:530

### setValidators

- setValidators(newValidator: Validator, updateValueAndValidity?: boolean): void

  Sets the synchronous validators that are active on this control. Calling this overwrites any existing synchronous validators.

  When you add or remove a validator at run time, you must call `updateValueAndValidity()` for the new validation to take effect.

  If you want to add a new validator without affecting existing ones, consider using `addValidators()` method instead.

  #### Parameters

  - newValidator: Validator
  - updateValueAndValidity: boolean = true

  #### Returns void

  Overrides UntypedFormGroup.setValidators

  - Defined in packages/angular/forms/src/lib/form-group.ts:330

### setValue

- setValue(
  valueOrObservable: Observable<T>,
  options?: ControlEventOptions,
  ): Subscription

  Sets the value of the `FormGroup`. It accepts an object that matches the structure of the group, with control names as keys.

  #### Parameters

  - valueOrObservable: Observable<T>
  - `Optional` options: ControlEventOptions

    Configuration options that determine how the control propagates changes and emits events after the value changes. The configuration options are passed to the updateValueAndValidity method.

    - `onlySelf`: When true, each change only affects this control, and not its parent. Default is false.
    - `emitEvent`: When true or not supplied (the default), both the `statusChanges` and `valueChanges` observables emit events with the latest status and value when the control value is updated. When false, no events are emitted.

  #### Returns Subscription

  #### Usage Notes

  ### Set the complete value for the form group

      const form = new FormGroup({
        first: new FormControl(),
        last: new FormControl()
      });

      console.log(form.value);   // {first: null, last: null}

      form.setValue({first: 'Nancy', last: 'Drew'});
      console.log(form.value);   // {first: 'Nancy', last: 'Drew'}

  #### Throws

  When strict checks fail, such as setting the value of a control that doesn't exist or if you exclude a value of a control that does exist.

  Overrides UntypedFormGroup.setValue

  - Defined in packages/angular/forms/src/lib/form-group.ts:206
- setValue(valueOrObservable: T, options?: ControlEventOptions): void

  #### Parameters

  - valueOrObservable: T
  - `Optional` options: ControlEventOptions

  #### Returns void

  Overrides UntypedFormGroup.setValue

  - Defined in packages/angular/forms/src/lib/form-group.ts:210

### updateValueAndValidity

- updateValueAndValidity(opts?: { emitEvent?: boolean; onlySelf?: boolean }): void

  Recalculates the value and validation status of the control.

  By default, it also updates the value and validity of its ancestors.

  #### Parameters

  - `Optional` opts: { emitEvent?: boolean; onlySelf?: boolean }

    Configuration options determine how the control propagates changes and emits events after updates and validity checks are applied.

    - `onlySelf`: When true, only update this control. When false or not supplied, update all direct ancestors. Default is false.
    - `emitEvent`: When true or not supplied (the default), the `statusChanges`, `valueChanges` and `events` observables emit events with the latest status and value when the control is updated. When false, no events are emitted.

  #### Returns void

  Inherited from UntypedFormGroup.updateValueAndValidity

  - Defined in node_modules/@angular/forms/index.d.ts:562

### validateOn

- validateOn(observableValidation: Observable<null | object>): Subscription

  #### Parameters

  - observableValidation: Observable<null | object>

  #### Returns Subscription

  - Defined in packages/angular/forms/src/lib/form-group.ts:350